---
title: EventSource()
slug: Web/API/EventSource/EventSource
tags:
  - API
  - Constructor
  - EventSource
  - Reference
  - Server-sent events
---
<div>{{APIRef('WebSockets API')}}</div>

<p>The <code><strong>EventSource</strong></code><strong><code>()</code></strong> constructor returns a newly-created {{domxref("EventSource")}}, which represents a remote resource.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">eventSource = new EventSource(<em>url</em>, <em>configuration</em>);</pre>

<h3 class="syntaxbox" id="Parameters">Parameters</h3>

<dl>
 <dt><code>url</code></dt>
 <dd>A {{domxref("USVString")}} that represents the location of the remote resource serving the events/messages.</dd>
 <dt><code>configuration</code> {{optional_inline}}</dt>
 <dd>Provides options to configure the new connection. The possible entries are:
 <ul>
  <li><code>withCredentials</code>, defaulting to <code>false</code>, indicating if CORS should be set to <code>include</code> credentials.</li>
 </ul>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var evtSource = new EventSource('sse.php');
var eventList = document.querySelector('ul');

evtSource.onmessage = function(e) {
  var newElement = document.createElement("li");

  newElement.textContent = "message: " + e.data;
  eventList.appendChild(newElement);
}</pre>

<div class="note">
<p><strong>Note</strong>: You can find a full example on GitHub — see <a href="https://github.com/mdn/dom-examples/tree/master/server-sent-events">Simple SSE demo using PHP.</a></p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "comms.html#dom-eventsource", "EventSource()")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<ul>
</ul>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.EventSource.EventSource")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("EventSource")}}</li>
</ul>
